import { GraphQLSchema, ValidationContext } from 'graphql';
import { LogFunction } from './runQuery';
export interface GraphQLServerOptions {
    schema: GraphQLSchema;
    formatError?: Function;
    rootValue?: any;
    context?: any;
    logFunction?: LogFunction;
    formatParams?: Function;
    validationRules?: Array<(context: ValidationContext) => any>;
    formatResponse?: Function;
    debug?: boolean;
}
export default GraphQLServerOptions;
export declare function resolveGraphqlOptions(options: GraphQLServerOptions | Function, ...args: any[]): Promise<GraphQLServerOptions>;
export declare function isOptionsFunction(arg: GraphQLServerOptions | Function): arg is Function;
